Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/moleculelist.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -4,4 +4,6 @@
  *
  */
+
+#include <cstring>
 
 #include "atom.hpp"
@@ -17,4 +19,5 @@
 #include "memoryallocator.hpp"
 #include "periodentafel.hpp"
+#include "World.hpp"
 
 /*********************************** Functions for class MoleculeListClass *************************/
@@ -33,10 +36,10 @@
 MoleculeListClass::~MoleculeListClass()
 {
-  Log() << Verbose(3) << this << ": Freeing ListOfMolcules." << endl;
+  DoLog(3) && (Log() << Verbose(3) << this << ": Freeing ListOfMolcules." << endl);
   for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
-    Log() << Verbose(4) << "ListOfMolecules: Freeing " << *ListRunner << "." << endl;
+    DoLog(4) && (Log() << Verbose(4) << "ListOfMolecules: Freeing " << *ListRunner << "." << endl);
     delete (*ListRunner);
   }
-  Log() << Verbose(4) << "Freeing ListOfMolecules." << endl;
+  DoLog(4) && (Log() << Verbose(4) << "Freeing ListOfMolecules." << endl);
   ListOfMolecules.clear(); // empty list
 };
@@ -142,8 +145,8 @@
 
   // header
-  Log() << Verbose(0) << "Index\tName\t\tAtoms\tFormula\tCenter\tSize" << endl;
-  Log() << Verbose(0) << "-----------------------------------------------" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Index\tName\t\tAtoms\tFormula\tCenter\tSize" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "-----------------------------------------------" << endl);
   if (ListOfMolecules.size() == 0)
-    Log() << Verbose(0) << "\tNone" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "\tNone" << endl);
   else {
     Origin.Zero();
@@ -162,13 +165,13 @@
       }
       // output Index, Name, number of atoms, chemical formula
-      Log() << Verbose(0) << ((*ListRunner)->ActiveFlag ? "*" : " ") << (*ListRunner)->IndexNr << "\t" << (*ListRunner)->name << "\t\t" << (*ListRunner)->AtomCount << "\t";
+      DoLog(0) && (Log() << Verbose(0) << ((*ListRunner)->ActiveFlag ? "*" : " ") << (*ListRunner)->IndexNr << "\t" << (*ListRunner)->name << "\t\t" << (*ListRunner)->AtomCount << "\t");
       Elemental = (*ListRunner)->elemente->end;
       while(Elemental->previous != (*ListRunner)->elemente->start) {
         Elemental = Elemental->previous;
         if (Counts[Elemental->Z] != 0)
-          Log() << Verbose(0) << Elemental->symbol << Counts[Elemental->Z];
+          DoLog(0) && (Log() << Verbose(0) << Elemental->symbol << Counts[Elemental->Z]);
       }
       // Center and size
-      Log() << Verbose(0) << "\t" << (*ListRunner)->Center << "\t" << sqrt(size) << endl;
+      DoLog(0) && (Log() << Verbose(0) << "\t" << (*ListRunner)->Center << "\t" << sqrt(size) << endl);
     }
   }
@@ -311,5 +314,5 @@
   Tesselation *TesselStruct = NULL;
   if ((srcmol == NULL) || (mol == NULL)) {
-    Log() << Verbose(1) << "ERROR: Either fixed or variable molecule is given as NULL." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Either fixed or variable molecule is given as NULL." << endl);
     return false;
   }
@@ -319,5 +322,5 @@
   FindNonConvexBorder(mol, TesselStruct, (const LinkedCell *&)LCList, 4., NULL);
   if (TesselStruct == NULL) {
-    Log() << Verbose(1) << "ERROR: Could not tesselate the fixed molecule." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Could not tesselate the fixed molecule." << endl);
     return false;
   }
@@ -336,5 +339,5 @@
   while (Walker->next != srcmol->end) {
     Walker = Walker->next;
-    Log() << Verbose(2) << "INFO: Current Walker is " << *Walker << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "INFO: Current Walker is " << *Walker << "." << endl);
     if (!TesselStruct->IsInnerPoint(Walker->x, LCList)) {
       CopyAtoms[Walker->nr] = new atom(Walker);
@@ -345,5 +348,5 @@
     }
   }
-  Log() << Verbose(1) << nr << " of " << srcmol->AtomCount << " atoms have been merged.";
+  DoLog(1) && (Log() << Verbose(1) << nr << " of " << srcmol->AtomCount << " atoms have been merged.");
 
   // go through all bonds and add as well
@@ -351,5 +354,5 @@
   while(Binder->next != srcmol->last) {
     Binder = Binder->next;
-    Log() << Verbose(3) << "Adding Bond between " << *CopyAtoms[Binder->leftatom->nr] << " and " << *CopyAtoms[Binder->rightatom->nr]<< "." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "Adding Bond between " << *CopyAtoms[Binder->leftatom->nr] << " and " << *CopyAtoms[Binder->rightatom->nr]<< "." << endl);
     mol->AddBond(CopyAtoms[Binder->leftatom->nr], CopyAtoms[Binder->rightatom->nr], Binder->BondDegree);
   }
@@ -363,8 +366,8 @@
 void MoleculeListClass::Output(ofstream *out)
 {
-  Log() << Verbose(1) << "MoleculeList: ";
+  DoLog(1) && (Log() << Verbose(1) << "MoleculeList: ");
   for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++)
-    Log() << Verbose(0) << *ListRunner << "\t";
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << *ListRunner << "\t");
+  DoLog(0) && (Log() << Verbose(0) << endl);
 };
 
@@ -392,5 +395,5 @@
   char *FragmentNumber = NULL;
 
-  Log() << Verbose(1) << "Saving hydrogen saturation correction ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving hydrogen saturation correction ... ");
   // 0. parse in fit constant files that should have the same dimension as the final energy files
   // 0a. find dimension of matrices with constants
@@ -402,6 +405,5 @@
   input.open(line.c_str());
   if (input == NULL) {
-    eLog() << Verbose(0) << endl << "Unable to open " << line << ", is the directory correct?"
-        << endl;
+    DoLog(1) && (Log() << Verbose(1) << endl << "Unable to open " << line << ", is the directory correct?" << endl);
     return false;
   }
@@ -420,5 +422,5 @@
     b++;
   }
-  Log() << Verbose(0) << "I recognized " << a << " columns and " << b << " rows, ";
+  DoLog(0) && (Log() << Verbose(0) << "I recognized " << a << " columns and " << b << " rows, ");
   input.close();
 
@@ -441,5 +443,6 @@
     input.open(line.c_str());
     if (input == NULL) {
-      eLog() << Verbose(0) << endl << "Unable to open " << line << ", is the directory correct?" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << endl << "Unable to open " << line << ", is the directory correct?" << endl);
+      performCriticalExit();
       return false;
     }
@@ -462,12 +465,12 @@
   }
   for (int k = 0; k < 3; k++) {
-    Log() << Verbose(0) << "Constants " << k << ":" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Constants " << k << ":" << endl);
     for (int j = 0; j < b; j++) {
       for (int i = 0; i < a; i++) {
-        Log() << Verbose(0) << FitConstant[k][i][j] << "\t";
+        DoLog(0) && (Log() << Verbose(0) << FitConstant[k][i][j] << "\t");
       }
-      Log() << Verbose(0) << endl;
-    }
-    Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << endl);
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
   }
 
@@ -557,5 +560,5 @@
   }
   Free(&FitConstant);
-  Log() << Verbose(0) << "done." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "done." << endl);
   return true;
 };
@@ -577,5 +580,5 @@
 
   // open file for the force factors
-  Log() << Verbose(1) << "Saving  force factors ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving  force factors ... ");
   line << path << "/" << FRAGMENTPREFIX << FORCESFILE;
   ForcesFile.open(line.str().c_str(), ios::out);
@@ -605,8 +608,8 @@
     }
     ForcesFile.close();
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
     status = false;
-    Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl);
   }
   ForcesFile.close();
@@ -636,5 +639,10 @@
   int FragmentCounter = 0;
   ofstream output;
-
+  double cell_size_backup[6];
+  double * const cell_size = World::get()->cell_size;
+
+  // backup cell_size
+  for (int i=0;i<6;i++)
+    cell_size_backup[i] = cell_size[i];
   // store the fragments as config and as xyz
   for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
@@ -643,6 +651,8 @@
     if (path != NULL)
       strcpy(PathBackup, path);
-    else
-      eLog() << Verbose(0) << "OutputConfigForListOfFragments: NULL default path obtained from config!" << endl;
+    else {
+      DoeLog(0) && (eLog()<< Verbose(0) << "OutputConfigForListOfFragments: NULL default path obtained from config!" << endl);
+      performCriticalExit();
+    }
 
     // correct periodic
@@ -653,9 +663,9 @@
     sprintf(FragmentName, "%s/%s%s.conf.xyz", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
     outputFragment.open(FragmentName, ios::out);
-    Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as XYZ ...";
+    DoLog(2) && (Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as XYZ ...");
     if ((intermediateResult = (*ListRunner)->OutputXYZ(&outputFragment)))
-      Log() << Verbose(0) << " done." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " done." << endl);
     else
-      Log() << Verbose(0) << " failed." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " failed." << endl);
     result = result && intermediateResult;
     outputFragment.close();
@@ -663,11 +673,11 @@
 
     // list atoms in fragment for debugging
-    Log() << Verbose(2) << "Contained atoms: ";
+    DoLog(2) && (Log() << Verbose(2) << "Contained atoms: ");
     Walker = (*ListRunner)->start;
     while (Walker->next != (*ListRunner)->end) {
       Walker = Walker->next;
-      Log() << Verbose(0) << Walker->Name << " ";
-    }
-    Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << Walker->Name << " ");
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
 
     // center on edge
@@ -678,5 +688,5 @@
       j += k + 1;
       BoxDimension.x[k] = 2.5 * (configuration->GetIsAngstroem() ? 1. : 1. / AtomicLengthToAngstroem);
-      (*ListRunner)->cell_size[j] += BoxDimension.x[k] * 2.;
+      cell_size[j] = BoxDimension.x[k] * 2.;
     }
     (*ListRunner)->Translate(&BoxDimension);
@@ -693,9 +703,9 @@
     // and save as config
     sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
-    Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as config ...";
+    DoLog(2) && (Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as config ...");
     if ((intermediateResult = configuration->Save(FragmentName, (*ListRunner)->elemente, (*ListRunner))))
-      Log() << Verbose(0) << " done." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " done." << endl);
     else
-      Log() << Verbose(0) << " failed." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " failed." << endl);
     result = result && intermediateResult;
 
@@ -705,9 +715,9 @@
     // and save as mpqc input file
     sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
-    Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as mpqc input ...";
+    DoLog(2) && (Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as mpqc input ...");
     if ((intermediateResult = configuration->SaveMPQC(FragmentName, (*ListRunner))))
-      Log() << Verbose(2) << " done." << endl;
+      DoLog(2) && (Log() << Verbose(2) << " done." << endl);
     else
-      Log() << Verbose(0) << " failed." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " failed." << endl);
 
     result = result && intermediateResult;
@@ -716,8 +726,12 @@
     Free(&FragmentNumber);
   }
-  Log() << Verbose(0) << " done." << endl;
+  DoLog(0) && (Log() << Verbose(0) << " done." << endl);
 
   // printing final number
-  Log() << Verbose(2) << "Final number of fragments: " << FragmentCounter << "." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Final number of fragments: " << FragmentCounter << "." << endl);
+
+  // restore cell_size
+  for (int i=0;i<6;i++)
+    cell_size[i] = cell_size_backup[i];
 
   return result;
@@ -737,11 +751,44 @@
 /** Dissects given \a *mol into connected subgraphs and inserts them as new molecules but with old atoms into \a this.
  * \param *out output stream for debugging
- * \param *mol molecule with atoms to dissect
+ * \param *periode periodentafel
  * \param *configuration config with BondGraph
  */
-void MoleculeListClass::DissectMoleculeIntoConnectedSubgraphs(molecule * const mol, config * const configuration)
-{
+void MoleculeListClass::DissectMoleculeIntoConnectedSubgraphs(const periodentafel * const periode, config * const configuration)
+{
+  molecule *mol = new molecule(periode);
+  atom *Walker = NULL;
+  atom *Advancer = NULL;
+  bond *Binder = NULL;
+  bond *Stepper = NULL;
+  // 0. gather all atoms into single molecule
+  for (MoleculeList::iterator MolRunner = ListOfMolecules.begin(); !ListOfMolecules.empty(); MolRunner = ListOfMolecules.begin()) {
+    // shift all atoms to new molecule
+    Advancer = (*MolRunner)->start->next;
+    while (Advancer != (*MolRunner)->end) {
+      Walker = Advancer;
+      Advancer = Advancer->next;
+      DoLog(3) && (Log() << Verbose(3) << "Re-linking " << *Walker << "..." << endl);
+      unlink(Walker);
+      Walker->father = Walker;
+      mol->AddAtom(Walker);    // counting starts at 1
+    }
+    // remove all bonds
+    Stepper = (*MolRunner)->first->next;
+    while (Stepper != (*MolRunner)->last) {
+      Binder = Stepper;
+      Stepper = Stepper->next;
+      delete(Binder);
+    }
+    // remove the molecule
+    delete(*MolRunner);
+    ListOfMolecules.erase(MolRunner);
+  }
+
   // 1. dissect the molecule into connected subgraphs
-  configuration ->BG->ConstructBondGraph(mol);
+  if (!configuration->BG->ConstructBondGraph(mol)) {
+    delete (mol);
+    DoeLog(1) && (eLog()<< Verbose(1) << "There are no bonds." << endl);
+    return;
+  }
 
   // 2. scan for connected subgraphs
@@ -750,4 +797,9 @@
   Subgraphs = mol->DepthFirstSearchAnalysis(BackEdgeStack);
   delete(BackEdgeStack);
+  if ((Subgraphs == NULL) || (Subgraphs->next == NULL)) {
+    delete (mol);
+    DoeLog(1) && (eLog()<< Verbose(1) << "There are no atoms." << endl);
+    return;
+  }
 
   // 3. dissect (the following construct is needed to have the atoms not in the order of the DFS, but in
@@ -757,8 +809,15 @@
   // 4a. create array of molecules to fill
   const int MolCount = Subgraphs->next->Count();
+  char number[MAXSTRINGSIZE];
   molecule **molecules = Malloc<molecule *>(MolCount, "config::Load() - **molecules");
   for (int i=0;i<MolCount;i++) {
     molecules[i] = (molecule*) new molecule(mol->elemente);
     molecules[i]->ActiveFlag = true;
+    strncpy(molecules[i]->name, mol->name, MAXSTRINGSIZE);
+    if (MolCount > 1) {
+      sprintf(number, "-%d", i+1);
+      strncat(molecules[i]->name, number, MAXSTRINGSIZE - strlen(mol->name) - 1);
+    }
+    DoLog(1) && (Log() << Verbose(1) << "MolName is " << molecules[i]->name << endl);
     insert(molecules[i]);
   }
@@ -768,5 +827,5 @@
   int *MolMap = Calloc<int>(mol->AtomCount, "config::Load() - *MolMap");
   MoleculeLeafClass *MolecularWalker = Subgraphs;
-  atom *Walker = NULL;
+  Walker = NULL;
   while (MolecularWalker->next != NULL) {
     MolecularWalker = MolecularWalker->next;
@@ -780,22 +839,29 @@
 
   // 4c. relocate atoms to new molecules and remove from Leafs
-  Walker = mol->start;
+  Walker = NULL;
   while (mol->start->next != mol->end) {
     Walker = mol->start->next;
     if ((Walker->nr <0) || (Walker->nr >= mol->AtomCount)) {
-      eLog() << Verbose(0) << "Index of atom " << *Walker << " is invalid!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Index of atom " << *Walker << " is invalid!" << endl);
       performCriticalExit();
     }
     FragmentCounter = MolMap[Walker->nr];
     if (FragmentCounter != 0) {
-      Log() << Verbose(3) << "Re-linking " << *Walker << "..." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "Re-linking " << *Walker << "..." << endl);
       unlink(Walker);
       molecules[FragmentCounter-1]->AddAtom(Walker);    // counting starts at 1
     } else {
-      eLog() << Verbose(0) << "Atom " << *Walker << " not associated to molecule!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Atom " << *Walker << " not associated to molecule!" << endl);
       performCriticalExit();
     }
   }
-  // 4d. we don't need to redo bonds, as they are connected subgraphs and still maintained their ListOfBonds
+  // 4d. we don't need to redo bonds, as they are connected subgraphs and still maintain their ListOfBonds, but we have to remove them from first..last list
+  Binder = mol->first;
+  while (mol->first->next != mol->last) {
+    Binder = mol->first->next;
+    Walker = Binder->leftatom;
+    unlink(Binder);
+    link(Binder,molecules[MolMap[Walker->nr]-1]->last);   // counting starts at 1
+  }
   // 4e. free Leafs
   MolecularWalker = Subgraphs;
@@ -807,6 +873,25 @@
   Free(&MolMap);
   Free(&molecules);
-  Log() << Verbose(1) << "I scanned " << FragmentCounter << " molecules." << endl;
-};
+  DoLog(1) && (Log() << Verbose(1) << "I scanned " << FragmentCounter << " molecules." << endl);
+};
+
+/** Count all atoms in each molecule.
+ * \return number of atoms in the MoleculeListClass.
+ * TODO: the inner loop should be done by some (double molecule::CountAtom()) function
+ */
+int MoleculeListClass::CountAllAtoms() const
+{
+  atom *Walker = NULL;
+  int AtomNo = 0;
+  for (MoleculeList::const_iterator MolWalker = ListOfMolecules.begin(); MolWalker != ListOfMolecules.end(); MolWalker++) {
+    Walker = (*MolWalker)->start;
+    while (Walker->next != (*MolWalker)->end) {
+      Walker = Walker->next;
+      AtomNo++;
+    }
+  }
+  return AtomNo;
+}
+
 
 /******************************************* Class MoleculeLeafClass ************************************************/
@@ -897,13 +982,13 @@
   int AtomNo;
 
-  Log() << Verbose(1) << "Begin of FillBondStructureFromReference." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of FillBondStructureFromReference." << endl);
   // fill ListOfLocalAtoms if NULL was given
   if (!FillListOfLocalAtoms(ListOfLocalAtoms, FragmentCounter, reference->AtomCount, FreeList)) {
-    Log() << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl);
     return false;
   }
 
   if (status) {
-    Log() << Verbose(1) << "Creating adjacency list for subgraph " << Leaf << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Creating adjacency list for subgraph " << Leaf << "." << endl);
     // remove every bond from the list
     bond *Binder = NULL;
@@ -926,5 +1011,5 @@
             Leaf->AddBond(Walker, OtherWalker, (*Runner)->BondDegree);
         } else {
-          Log() << Verbose(1) << "OtherWalker = ListOfLocalAtoms[" << FragmentCounter << "][" << (*Runner)->GetOtherAtom(Walker->GetTrueFather())->nr << "] is NULL!" << endl;
+          DoLog(1) && (Log() << Verbose(1) << "OtherWalker = ListOfLocalAtoms[" << FragmentCounter << "][" << (*Runner)->GetOtherAtom(Walker->GetTrueFather())->nr << "] is NULL!" << endl);
           status = false;
         }
@@ -939,5 +1024,5 @@
       Free(&ListOfLocalAtoms);
   }
-  Log() << Verbose(1) << "End of FillBondStructureFromReference." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "End of FillBondStructureFromReference." << endl);
   return status;
 };
@@ -972,5 +1057,5 @@
         next->FillRootStackForSubgraphs(RootStack, AtomMask, ++FragmentCounter);
     } else {
-      Log() << Verbose(1) << "Rootstack[" << FragmentCounter << "] is NULL." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Rootstack[" << FragmentCounter << "] is NULL." << endl);
       return false;
     }
@@ -978,5 +1063,5 @@
     return true;
   } else {
-    Log() << Verbose(1) << "Rootstack is NULL." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Rootstack is NULL." << endl);
     return false;
   }
@@ -1028,8 +1113,8 @@
   int KeySetCounter = 0;
 
-  Log() << Verbose(1) << "Begin of AssignKeySetsToFragment." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of AssignKeySetsToFragment." << endl);
   // fill ListOfLocalAtoms if NULL was given
   if (!FillListOfLocalAtoms(ListOfLocalAtoms, FragmentCounter, reference->AtomCount, FreeList)) {
-    Log() << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl);
     return false;
   }
@@ -1059,8 +1144,8 @@
     delete (TempSet);
     if (KeySetCounter == 0) {// if there are no keysets, delete the list
-      Log() << Verbose(1) << "KeySetCounter is zero, deleting FragmentList." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "KeySetCounter is zero, deleting FragmentList." << endl);
       delete (FragmentList[FragmentCounter]);
     } else
-      Log() << Verbose(1) << KeySetCounter << " keysets were assigned to subgraph " << FragmentCounter << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << KeySetCounter << " keysets were assigned to subgraph " << FragmentCounter << "." << endl);
     FragmentCounter++;
     if (next != NULL)
@@ -1068,5 +1153,5 @@
     FragmentCounter--;
   } else
-    Log() << Verbose(1) << "KeySetList is NULL or empty." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "KeySetList is NULL or empty." << endl);
 
   if ((FreeList) && (ListOfLocalAtoms != NULL)) {
@@ -1076,5 +1161,5 @@
       Free(&ListOfLocalAtoms);
   }
-  Log() << Verbose(1) << "End of AssignKeySetsToFragment." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "End of AssignKeySetsToFragment." << endl);
   return status;
 };
@@ -1089,5 +1174,5 @@
 void MoleculeLeafClass::TranslateIndicesToGlobalIDs(Graph **FragmentList, int &FragmentCounter, int &TotalNumberOfKeySets, Graph &TotalGraph)
 {
-  Log() << Verbose(1) << "Begin of TranslateIndicesToGlobalIDs." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of TranslateIndicesToGlobalIDs." << endl);
   KeySet *TempSet = new KeySet;
   if (FragmentList[FragmentCounter] != NULL) {
@@ -1100,10 +1185,10 @@
     delete (TempSet);
   } else {
-    Log() << Verbose(1) << "FragmentList is NULL." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "FragmentList is NULL." << endl);
   }
   if (next != NULL)
     next->TranslateIndicesToGlobalIDs(FragmentList, ++FragmentCounter, TotalNumberOfKeySets, TotalGraph);
   FragmentCounter--;
-  Log() << Verbose(1) << "End of TranslateIndicesToGlobalIDs." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "End of TranslateIndicesToGlobalIDs." << endl);
 };
 
